<?php
/* Autor...:  */
/* Esquema.: PLA_MarcacionTipo.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Metodos de acceso a los campos de la tabla PLA_MarcacionTipo */
abstract class BasePLA_MarcacionTipoBN
{
    /* Campos de la tabla */
    private $s_IdTipo;    // IdTipo: ( no definido )
    private $s_IdRegistro;    // IdRegistro: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $i_Secuencia;    // Secuencia: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $i_TieneDescuentoFlag;    // TieneDescuentoFlag: ( no definido )
    private $i_TieneDiaSiguienteFlag;    // TieneDiaSiguienteFlag: ( no definido )

    /* Establece el valor del campo IdTipo */
    public function setIdTipo( $s_IdTipo )
    {
        $this->s_IdTipo = $s_IdTipo;
    }

    /* Obtiene el valor del campo IdTipo */
    public function getIdTipo()
    {
        return $this->s_IdTipo;
    }

    /* Establece el valor del campo IdRegistro */
    public function setIdRegistro( $s_IdRegistro )
    {
        $this->s_IdRegistro = $s_IdRegistro;
    }

    /* Obtiene el valor del campo IdRegistro */
    public function getIdRegistro()
    {
        return $this->s_IdRegistro;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Secuencia */
    public function setSecuencia( $i_Secuencia )
    {
        $this->i_Secuencia = $i_Secuencia;
    }

    /* Obtiene el valor del campo Secuencia */
    public function getSecuencia()
    {
        return $this->i_Secuencia;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo TieneDescuentoFlag */
    public function setTieneDescuentoFlag( $i_TieneDescuentoFlag )
    {
        $this->i_TieneDescuentoFlag = $i_TieneDescuentoFlag;
    }

    /* Obtiene el valor del campo TieneDescuentoFlag */
    public function getTieneDescuentoFlag()
    {
        return $this->i_TieneDescuentoFlag;
    }

    /* Establece el valor del campo TieneDiaSiguienteFlag */
    public function setTieneDiaSiguienteFlag( $i_TieneDiaSiguienteFlag )
    {
        $this->i_TieneDiaSiguienteFlag = $i_TieneDiaSiguienteFlag;
    }

    /* Obtiene el valor del campo TieneDiaSiguienteFlag */
    public function getTieneDiaSiguienteFlag()
    {
        return $this->i_TieneDiaSiguienteFlag;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdTipo' => $this->getIdTipo(),
            'IdRegistro' => $this->getIdRegistro(),
            'Descripcion' => $this->getDescripcion(),
            'Secuencia' => $this->getSecuencia(),
            'Estado' => $this->getEstado(),
            'TieneDescuentoFlag' => $this->getTieneDescuentoFlag(),
            'TieneDiaSiguienteFlag' => $this->getTieneDiaSiguienteFlag(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto PLA_MarcacionTipoBN desde un RecordSet */
    public static function retrieveByRs( $o_PLA_MarcacionTipoRs )
    {
        $o_PLA_MarcacionTipoBN = new PLA_MarcacionTipoBN();
        $o_PLA_MarcacionTipoBN->setIdTipo( $o_PLA_MarcacionTipoRs[ "IdTipo" ] );
        $o_PLA_MarcacionTipoBN->setIdRegistro( $o_PLA_MarcacionTipoRs[ "IdRegistro" ] );
        $o_PLA_MarcacionTipoBN->setDescripcion( $o_PLA_MarcacionTipoRs[ "Descripcion" ] );
        $o_PLA_MarcacionTipoBN->setSecuencia( ( integer ) $o_PLA_MarcacionTipoRs[ "Secuencia" ] );
        $o_PLA_MarcacionTipoBN->setEstado( $o_PLA_MarcacionTipoRs[ "Estado" ] );
        $o_PLA_MarcacionTipoBN->setTieneDescuentoFlag( ( integer ) $o_PLA_MarcacionTipoRs[ "TieneDescuentoFlag" ] );
        $o_PLA_MarcacionTipoBN->setTieneDiaSiguienteFlag( ( integer ) $o_PLA_MarcacionTipoRs[ "TieneDiaSiguienteFlag" ] );
        return $o_PLA_MarcacionTipoBN;
    }
}
?>